﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Themes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System.Windows.Markup;

namespace Grid_Themes
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }


        public void SetExternalDRCAStyle(string ThemeName)
        {
            string stylestring = @"<Style  xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'  " +
                                         " xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml' " +
                                         " xmlns:igDP='http://infragistics.com/DataPresenter' " +
                                         "xmlns:igTheme" + ThemeName + "='http://infragistics.com/Themes/" + ThemeName + "'" +
                                         " BasedOn='{x:Static igTheme" + ThemeName + ":DataPresenter.DataRecordCellArea}' " +
                                         " TargetType='{x:Type igDP:DataRecordCellArea}' >" +

                                       "<Setter Property='Background' Value='BlueViolet' /> " +
                                       "<Setter Property='BackgroundHover' Value='Transparent' /> " +
                                   "</Style>   ";

            Style currentStyle = XamlReader.Parse(stylestring) as Style;
            xamDataGrid1.Resources.Remove(typeof(DataRecordCellArea));
            xamDataGrid1.Resources.Add(typeof(DataRecordCellArea), currentStyle);
        }


        public void SetDRCAStyle(string ThemeName)
        {
            string stylestring = @"<Style  xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'  " +
                                         " xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml' " +
                                         " xmlns:igDP='http://infragistics.com/DataPresenter' " +
                                         " BasedOn='{x:Static igThemes:DataPresenter" + ThemeName + ".DataRecordCellArea}' " +
                                         " TargetType='{x:Type igDP:DataRecordCellArea}' " + 
                                         " xmlns:igThemes='http://infragistics.com/Themes'>" +
                                       "<Setter Property='Background' Value='BlueViolet' /> " +
                                       "<Setter Property='BackgroundHover' Value='Transparent' /> " + 
                                   "</Style>   ";

            Style currentStyle = XamlReader.Parse(stylestring) as Style;
            xamDataGrid1.Resources.Remove(typeof(DataRecordCellArea));
            xamDataGrid1.Resources.Add(typeof(DataRecordCellArea), currentStyle);
        }


        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            switch ((sender as ComboBox).SelectedIndex)
            {
                case 0:
                    {
                        SetDRCAStyle("Aero");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameAero; 
                        break;
                    }
                case 1:
                    {
                        SetDRCAStyle("Generic");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameGeneric; 
                        break;
                    }
                case 2:
                    {
                        SetDRCAStyle("LunaNormal");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaNormal; 
                        break;
                    }
                case 3:
                    {
                        SetDRCAStyle("LunaOlive");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaOlive; 
                        break;
                    }
                case 4:
                    {
                        SetDRCAStyle("LunaSilver");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameLunaSilver; 
                        break;
                    }
                case 5:
                    {
                        SetDRCAStyle("Office2k7Black");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Black; 
                        break;
                    }
                case 6:
                    {
                        SetDRCAStyle("Office2k7Blue");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Blue;
                        break;
                    }
                case 7:
                    {
                        SetDRCAStyle("Office2k7Silver");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameOffice2k7Silver; 
                        break;
                    }
                case 8:
                    {
                        SetDRCAStyle("Onyx");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameOnyx;
                        break;
                    }
                case 9:
                    {
                        SetDRCAStyle("PrintBasic");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNamePrintBasic;
                        break;
                    }
                case 10:
                    {
                        SetDRCAStyle("Royale");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameRoyale; 
                        break;
                    }

                case 11:
                    {
                        SetDRCAStyle("RoyaleStrong");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameRoyaleStrong;
                        break;
                    }
                case 12:
                    {
                        SetExternalDRCAStyle("Fall");
                        ResourceSet fall = new Infragistics.Windows.Themes.Fall.DataPresenter();
                        ThemeManager.CurrentTheme = fall.Theme;
                        break;
                    }
                case 13:
                    {
                        SetExternalDRCAStyle("ForestGreen");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameForestGreen;
                        break;
                    }
                case 14:
                    {
                        SetExternalDRCAStyle("Leaf");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameLeaf;
                        break;
                    }
                case 15:
                    {
                        SetExternalDRCAStyle("Lipstick");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameLipstick;
                        break;
                    }
                case 16:
                    {
                        SetExternalDRCAStyle("Water");
                        ResourceSet water = new Infragistics.Windows.Themes.Water.DataPresenter();
                        ThemeManager.CurrentTheme = water.Theme;
                        break;
                    }
                case 17:
                    {
                        SetExternalDRCAStyle("Wind");
                        ResourceSet wind =new  Infragistics.Windows.Themes.Wind.DataPresenter();
                        ThemeManager.CurrentTheme = wind.Theme;
                        break;
                    }

                default:
                    {
                        SetDRCAStyle("Generic");
                        ThemeManager.CurrentTheme = ThemeManager.ThemeNameGeneric; 
                        break;
                    }
            }
        }
    }
}
